(POJ - 3126)Prime Path

(POJ - 3126)Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 22759 Accepted: 12606

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
这里写图片描述

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题目大意:给定两个四位素数a,b,每次变换都可以改变任意一位上的数字,但是必须保证变换后的数字也是四位素数。问:把a变成b的最少变换次数,若不能则输出“Impossible”。

思路:对于四位素数可以通过普通筛求素数发预处理出来。千位上的数字可以是(1,2……9),百位十位上的数字可以是(0,1,……9),而个位上的数字只可能是奇数(因为要保证其为素数),对于各种情况广搜即可,因为是广搜,就保证了是最少的次数。

#include<cstdio> 
#include<cstring>
#include<queue>
using namespace std;

const int maxn=10005;
bool prime[maxn],vis[maxn];
int a,b;

struct node
{
    int x,step;
};

void isprime()
{
    memset(prime,0,sizeof(prime));//素数为0 
    prime[0]=prime[1]=1;
    for(int i=2;i<maxn;i++)
        if(!prime[i])
        {
            for(int j=i<<1;j<maxn;j+=i)
                prime[j]=1;
        }
}

int bfs()
{
    queue<node> q;
    node start,tmp,next;
    start.x=a;
    start.step=0;
    vis[a]=1;
    q.push(start);
    while(!q.empty())
    {
        tmp=q.front();
        q.pop();
        if(tmp.x==b) return tmp.step;
        for(int i=1;i<=9;i++)
        {
            next.x=1000*i+tmp.x%1000;
            if(!prime[next.x]&&!vis[next.x])
            {
                next.step=tmp.step+1;
                vis[next.x]=1;
                q.push(next);
            }
        }
        for(int i=0;i<=9;i++)
        {
            next.x=tmp.x/1000*1000+i*100+tmp.x%100;
            if(!prime[next.x]&&!vis[next.x])
            {
                next.step=tmp.step+1;
                vis[next.x]=1;
                q.push(next);
            }
        }
        for(int i=0;i<=9;i++)
        {
            next.x=tmp.x/100*100+i*10+tmp.x%10;
            if(!prime[next.x]&&!vis[next.x])
            {
                next.step=tmp.step+1;
                vis[next.x]=1;
                q.push(next);
            }
        }
        for(int i=1;i<=9;i+=2)
        {
            next.x=tmp.x/10*10+i;
            if(!prime[next.x]&&!vis[next.x])
            {
                next.step=tmp.step+1;
                vis[next.x]=1;
                q.push(next);
            }
        }
    }
    return -1;
}

int main()
{
    isprime();
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d",&a,&b);
        memset(vis,0,sizeof(vis));
        int ans=bfs();
        if(ans!=-1) printf("%d\n",ans);
        else printf("Impossible\n");
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值